=begin
A subclass of Tkinter.PhotoImage that connects a
vtkImageData to a photo widget.
=end

require 'tk'
require 'vtk'
require 'vtk/tk/vtkLoadRubyTkWidgets'

class Vtk::TkPhotoImage < TkPhotoImage
=begin
    A subclass of PhotoImage with helper functions
    A subend
    for displaying vtkImageData
=end
  def initialize( kw={} )
    # Caller the superclass
    super( kw )
    Vtk.LoadRubyTkWidgets
  end
  def PutImageSlice ( image, z, options={} )
    default_options = { 'orientation'=>'transverse', 'window'=>256, 'level'=>128 }
    default_options.update( options )
    options = default_options
    t = "_"+image.GetAddressAsString('vtkImageData')[5..-1]+"_"+image.GetClassName
    Tk.tk_call("vtkImageDataToTkPhoto", t, @path, "%d"%z, options['orientation'], "%d"%options['window'], "%d"%options['level'])
  end
end
