#----------------------------------------------------------------------
# the following functions are for the vtk regression testing and examples

def vtkGetDataRoot
    dataIndex=-1;
    for i in 0..ARGV.length
        if ARGV[i] == '-D' && i < ARGV.length-1:
            dataIndex = i+1
        end
    end

    if dataIndex != -1
        dataRoot = ARGV[dataIndex]
    else
        unless dataRoot = ENV['VTK_DATA_ROOT']
            dataRoot = '../../../../VTKData'
        end
    end

    return dataRoot
end


def vtkRegressionTestImage( renWin )
    imageIndex=-1;
    for i in 0..ARGV.length
        if ARGV[i] == '-V' && i < ARGV.length-1:
            imageIndex = i+1
        end
    end

    if imageIndex != -1
        fname = File.join(vtkGetDataRoot(), ARGV[imageIndex])

        rt_w2if = vtk.vtkWindowToImageFilter()
        rt_w2if.SetInput(renWin)

        if File.exist?(fname)
            pass
        else
            rt_pngw = vtk.vtkPNGWriter()
            rt_pngw.SetFileName(fname)
            rt_pngw.SetInput(rt_w2if.GetOutput())
            rt_pngw.Write()
            rt_pngw = nil
        end

        rt_png = vtk.vtkPNGReader()
        rt_png.SetFileName(fname)

        rt_id = vtk.vtkImageDifference()
        rt_id.SetInput(rt_w2if.GetOutput())
        rt_id.SetImage(rt_png.GetOutput())
        rt_id.Update()

        if rt_id.GetThresholdedError() <= 10
            return 1
        else
            $stderr.print("Failed image test: %f\n",
                             rt_id.GetThresholdedError())
            return 0
        end
    end

    return 2
end

            
